"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ngxFirebaseWebAuthn = void 0;
const tslib_1 = require("tslib");
const server_1 = require("@simplewebauthn/server");
const auth_1 = require("firebase-admin/auth");
const firestore_1 = require("firebase-admin/firestore");
const firebase_functions_1 = require("firebase-functions");
exports.ngxFirebaseWebAuthn = (0, firebase_functions_1.runWith)({
    enforceAppCheck: true,
})
    .https
    .onCall((functionRequest, callableContext) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
    return callableContext.auth ? ((auth, firestore) => {
        var _a, _b, _c, _d, _e, _f, _g;
        return functionRequest.type === "clear challenge" ? firestore.collection("ngxFirebaseWebAuthnUsers").doc((_a = callableContext.auth) === null || _a === void 0 ? void 0 : _a.uid).get().then((userDocumentSnapshot) => ((userDocument) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
            var _h, _j;
            return userDocument ? userDocument.challenge ? userDocument.credentialId && userDocument.credentialPublicKey ? firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_h = callableContext.auth) === null || _h === void 0 ? void 0 : _h.uid) || "").update({
                challenge: firestore_1.FieldValue.delete(),
            }).then(() => ({
                success: true,
                type: functionRequest.type,
            })) : firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_j = callableContext.auth) === null || _j === void 0 ? void 0 : _j.uid) || "").delete().then(() => ({
                success: true,
                type: functionRequest.type,
            })) : {
                success: false,
                type: functionRequest.type,
                message: "no action",
            } : {
                message: "missing user doc",
                success: false,
                type: functionRequest.type,
            };
        }))(userDocumentSnapshot.data())) : functionRequest.type === "create authentication challenge" ? ((publicKeyCredentialRequestOptionsJSON) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
            var _k;
            return firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_k = callableContext.auth) === null || _k === void 0 ? void 0 : _k.uid) || "").set({
                challenge: publicKeyCredentialRequestOptionsJSON.challenge,
            }, {
                merge: true,
            }).then(() => ({
                requestOptions: publicKeyCredentialRequestOptionsJSON,
                success: true,
                type: functionRequest.type,
            }));
        }))((0, server_1.generateAuthenticationOptions)({
            rpID: callableContext.rawRequest.hostname,
            userVerification: "required",
        })) : functionRequest.type === "create reauthentication challenge" ? firestore.collection("ngxFirebaseWebAuthnUsers").doc((_b = callableContext.auth) === null || _b === void 0 ? void 0 : _b.uid).get().then((userDocumentSnapshot) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
            return ((userDocument) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                return userDocument ? userDocument.credentialId && userDocument.credentialPublicKey ? ((publicKeyCredentialRequestOptions) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                    var _l;
                    return firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_l = callableContext.auth) === null || _l === void 0 ? void 0 : _l.uid) || "").set({
                        challenge: publicKeyCredentialRequestOptions.challenge,
                    }, {
                        merge: true,
                    }).then(() => ({
                        requestOptions: publicKeyCredentialRequestOptions,
                        success: true,
                        type: functionRequest.type,
                    }));
                }))((0, server_1.generateAuthenticationOptions)({
                    allowCredentials: [
                        {
                            id: userDocument.credentialId,
                            type: "public-key",
                        },
                    ],
                    rpID: callableContext.rawRequest.hostname,
                    userVerification: "required",
                })) : {
                    message: "user doc missing passkey fields",
                    success: false,
                    type: functionRequest.type,
                } : {
                    message: "missing user doc",
                    success: false,
                    type: functionRequest.type,
                };
            }))(userDocumentSnapshot.data());
        })) : functionRequest.type === "create registration challenge" ? firestore.collection("ngxFirebaseWebAuthnUsers").doc((_c = callableContext.auth) === null || _c === void 0 ? void 0 : _c.uid).get().then((userDocumentSnapshot) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
            return ((userDocument) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                var _m;
                return !(userDocument === null || userDocument === void 0 ? void 0 : userDocument.credentialPublicKey) ? ((publicKeyCredentialCreationOptions) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                    var _o;
                    return firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_o = callableContext.auth) === null || _o === void 0 ? void 0 : _o.uid) || "").set({
                        challenge: publicKeyCredentialCreationOptions.challenge,
                    }).then(() => ({
                        creationOptions: publicKeyCredentialCreationOptions,
                        success: true,
                        type: functionRequest.type,
                    }));
                }))((0, server_1.generateRegistrationOptions)({
                    authenticatorSelection: {
                        residentKey: "required",
                        userVerification: "required",
                    },
                    rpID: callableContext.rawRequest.hostname,
                    rpName: callableContext.rawRequest.hostname,
                    userID: ((_m = callableContext.auth) === null || _m === void 0 ? void 0 : _m.uid) || "",
                    userName: functionRequest.name,
                })) : {
                    message: "no action",
                    success: false,
                    type: functionRequest.type,
                };
            }))(userDocumentSnapshot.data());
        })) : functionRequest.type === "verify authentication" ? functionRequest.authenticationResponse.response.userHandle !== ((_d = callableContext.auth) === null || _d === void 0 ? void 0 : _d.uid) ? firestore.collection("ngxFirebaseWebAuthnUsers").doc(functionRequest.authenticationResponse.response.userHandle || "").get().then((userDocumentSnapshot) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
            return ((userDocument) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                var _p, _q, _r;
                return userDocument ? userDocument.credentialId && userDocument.credentialPublicKey ? firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_p = callableContext.auth) === null || _p === void 0 ? void 0 : _p.uid) || "").get().then((anonymousUserDocumentSnapshot) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                    return ((anonymousUserDocument) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                        var _s;
                        return anonymousUserDocument && anonymousUserDocument.challenge ? (0, server_1.verifyAuthenticationResponse)({
                            authenticator: {
                                // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
                                counter: userDocument.credentialCounter,
                                // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
                                credentialID: userDocument.credentialId,
                                // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
                                credentialPublicKey: userDocument.credentialPublicKey,
                            },
                            expectedChallenge: anonymousUserDocument.challenge,
                            expectedOrigin: "https://" + callableContext.rawRequest.hostname,
                            expectedRPID: callableContext.rawRequest.hostname,
                            requireUserVerification: true,
                            response: functionRequest.authenticationResponse,
                        }).then((verifiedAuthenticationResponse) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                            var _t;
                            return verifiedAuthenticationResponse.verified ? firestore.collection("ngxFirebaseWebAuthnUsers").doc(functionRequest.authenticationResponse.response.userHandle || "").update({
                                challenge: firestore_1.FieldValue.delete(),
                                lastVerified: firestore_1.Timestamp.fromDate(new Date()),
                            }).then(() => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                                var _u, _v;
                                return anonymousUserDocument.credentialId && anonymousUserDocument.credentialPublicKey ? firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_u = callableContext.auth) === null || _u === void 0 ? void 0 : _u.uid) || "").update({
                                    challenge: firestore_1.FieldValue.delete(),
                                }).then(() => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                                    return auth.createCustomToken(functionRequest.authenticationResponse.response.userHandle || "").then((customToken) => ({
                                        customToken: customToken,
                                        success: true,
                                        type: functionRequest.type,
                                    }));
                                })) : firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_v = callableContext.auth) === null || _v === void 0 ? void 0 : _v.uid) || "").delete().then(() => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                                    return auth.createCustomToken(functionRequest.authenticationResponse.response.userHandle || "").then((customToken) => ({
                                        customToken: customToken,
                                        success: true,
                                        type: functionRequest.type,
                                    }));
                                }));
                            })) : firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_t = callableContext.auth) === null || _t === void 0 ? void 0 : _t.uid) || "").delete().then(() => ({
                                message: "not verified",
                                success: false,
                                type: functionRequest.type,
                            }));
                        })) : firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_s = callableContext.auth) === null || _s === void 0 ? void 0 : _s.uid) || "").delete().then(() => ({
                            message: "user doc missing challenge field",
                            success: false,
                            type: functionRequest.type,
                        }));
                    }))(anonymousUserDocumentSnapshot.data());
                })) : firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_q = callableContext.auth) === null || _q === void 0 ? void 0 : _q.uid) || "").delete().then(() => ({
                    message: "user doc missing passkey fields",
                    success: false,
                    type: functionRequest.type,
                })) : firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_r = callableContext.auth) === null || _r === void 0 ? void 0 : _r.uid) || "").delete().then(() => ({
                    message: "missing user doc",
                    success: false,
                    type: functionRequest.type,
                }));
            }))(userDocumentSnapshot.data());
        })) : firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_e = callableContext.auth) === null || _e === void 0 ? void 0 : _e.uid) || "").update({
            challenge: firestore_1.FieldValue.delete(),
        }).then(() => ({
            message: "no action",
            success: false,
            type: functionRequest.type,
        })) : functionRequest.type === "verify reauthentication" ? firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_f = callableContext.auth) === null || _f === void 0 ? void 0 : _f.uid) || "").get().then((userDocumentSnapshot) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
            return ((userDocument) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                var _w;
                return userDocument ? userDocument.credentialId && userDocument.credentialPublicKey ? (() => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                    return userDocument.challenge ? (0, server_1.verifyAuthenticationResponse)({
                        authenticator: {
                            // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
                            counter: userDocument.credentialCounter,
                            // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
                            credentialID: userDocument.credentialId,
                            // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
                            credentialPublicKey: userDocument.credentialPublicKey,
                        },
                        expectedChallenge: userDocument.challenge,
                        expectedOrigin: "https://" + callableContext.rawRequest.hostname,
                        expectedRPID: callableContext.rawRequest.hostname,
                        requireUserVerification: true,
                        response: functionRequest.authenticationResponse,
                    }).then((verifiedAuthenticationResponse) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                        var _x, _y;
                        return verifiedAuthenticationResponse.verified ? firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_x = callableContext.auth) === null || _x === void 0 ? void 0 : _x.uid) || "").update({
                            challenge: firestore_1.FieldValue.delete(),
                            lastVerified: firestore_1.Timestamp.fromDate(new Date()),
                        }).then(() => ({
                            customToken: "",
                            success: true,
                            type: functionRequest.type,
                        })) : firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_y = callableContext.auth) === null || _y === void 0 ? void 0 : _y.uid) || "").update({
                            challenge: firestore_1.FieldValue.delete(),
                        }).then(() => ({
                            message: "not verified",
                            success: false,
                            type: functionRequest.type,
                        }));
                    })) : {
                        message: "user doc missing challenge field",
                        success: false,
                        type: functionRequest.type,
                    };
                }))() : firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_w = callableContext.auth) === null || _w === void 0 ? void 0 : _w.uid) || "").delete().then(() => ({
                    message: "user doc missing passkey fields",
                    success: false,
                    type: functionRequest.type,
                })) : {
                    message: "missing user doc",
                    success: false,
                    type: functionRequest.type,
                };
            }))(userDocumentSnapshot.data());
        })) : functionRequest.type === "verify registration" ? firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_g = callableContext.auth) === null || _g === void 0 ? void 0 : _g.uid) || "").get().then((userDocumentSnapshot) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
            return ((userDocument) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                var _z;
                return userDocument ? userDocument.challenge ? (0, server_1.verifyRegistrationResponse)({
                    expectedChallenge: userDocument["challenge"],
                    expectedOrigin: "https://" + callableContext.rawRequest.hostname,
                    expectedRPID: callableContext.rawRequest.hostname,
                    requireUserVerification: true,
                    response: functionRequest.registrationResponse,
                }).then((verifiedRegistrationResponse) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                    var _0, _1, _2, _3, _4;
                    return verifiedRegistrationResponse.verified ? firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_0 = callableContext.auth) === null || _0 === void 0 ? void 0 : _0.uid) || "").update({
                        challenge: firestore_1.FieldValue.delete(),
                        credentialCounter: (_1 = verifiedRegistrationResponse.registrationInfo) === null || _1 === void 0 ? void 0 : _1.counter,
                        credentialId: (_2 = verifiedRegistrationResponse.registrationInfo) === null || _2 === void 0 ? void 0 : _2.credentialID,
                        credentialPublicKey: (_3 = verifiedRegistrationResponse.registrationInfo) === null || _3 === void 0 ? void 0 : _3.credentialPublicKey,
                        lastVerified: firestore_1.Timestamp.fromDate(new Date()),
                    }).then(() => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                        var _5;
                        return auth.createCustomToken(((_5 = callableContext.auth) === null || _5 === void 0 ? void 0 : _5.uid) || "").then((customToken) => ({
                            customToken: customToken,
                            success: true,
                            type: functionRequest.type,
                        }));
                    })) : firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_4 = callableContext.auth) === null || _4 === void 0 ? void 0 : _4.uid) || "").delete().then(() => ({
                        message: "not verified",
                        success: false,
                        type: functionRequest.type,
                    }));
                })) : firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_z = callableContext.auth) === null || _z === void 0 ? void 0 : _z.uid) || "").delete().then(() => ({
                    message: "user doc missing challenge field",
                    success: false,
                    type: functionRequest.type,
                })) : {
                    message: "missing user doc",
                    success: false,
                    type: functionRequest.type,
                };
            }))(userDocumentSnapshot.data());
        })) : (() => {
            throw new Error("Invalid function request type.");
        })();
    })((0, auth_1.getAuth)(), (0, firestore_1.getFirestore)()) : {
        message: "missing auth",
        success: false,
        type: functionRequest.type,
    };
}));
//# sourceMappingURL=index.js.map